# Home lab configuration
The nix based configuration for my home lab.

## File Organization
```
- hosts/        # Host definitions files
- roles/        # Role definition files
- secrets/      # Encrypted secrets for each host
- systems/base/ # Base system configuration shared by all hosts

- confgi.nix    # Global configuration options
```

## Roles

### Traefik
HTTP reverse proxy.

## TODO:
### Services
**For sure**:
- Authentik: Authentication
- Forgejo: Git server
- FreshRSS: RSS server/reader
- Gramps: Family tree
- hoarder: Bookmark manager
- immich: Fotos
- Jellyfin: Watching media files
- Nextcloud: Files, contacts, calendar, etc
- Pterodactyl panel: Game servers
- Pterodactyl wings: Backend daemon for game servers
- Vaultwarden: Password manager

**Needs to run over VPN:**
- Prowlarr: 
- Radarr:
- Lidarr: 
- Sonarr:
- Transmission: Torrent clients (Different client maybe?)

**Websites**:
Might want to look at using something to host these + other self hosted projects like coolify on its own machine

- kallestruik.nl
- dchat.kallestruik.nl
- dconfig.kallestruik.nl
- shs.khs.li
- shs-gc.khs.li

**Maybe**:
- Hedgedoc: Shared markdown note editing
- Linkwarden: Shared link collections
- Mastodon: Federated social media
- Matrix: Federated chat
- Paperless: Document storage
- Stirling PDF: PDF tools

**Monitoring**:
Currently grafana for dashboard with other things supplying data into it. Might want to look at some options before using it again.

**Bastion**:
- VPN
- SSH jumphost to the rest of the network

### Unmanaged hosts
These need to have traefik configs created for them without being managed by the config.
- Bluesky PDS
- Home Assistant



